import { Bound } from "@canvas-js/okra";
import { AbstractMessageLog, MessageLogInit, ReadOnlyTransaction, ReadWriteTransaction } from "../AbstractMessageLog.js";
export declare class MessageLog<Payload, Result> extends AbstractMessageLog<Payload, Result> {
    private readonly env;
    static open<Payload, Result>(path: string, init: MessageLogInit<Payload, Result>): Promise<MessageLog<Payload, Result>>;
    private constructor();
    close(): Promise<void>;
    entries(lowerBound?: Bound<Uint8Array> | null, upperBound?: Bound<Uint8Array> | null, options?: {
        reverse?: boolean;
    }): AsyncIterable<[key: Uint8Array, value: Uint8Array]>;
    read<T>(callback: (txn: ReadOnlyTransaction) => Promise<T>): Promise<T>;
    write<T>(callback: (txn: ReadWriteTransaction) => Promise<T>): Promise<T>;
}
